/*

  file    : bitstr.c
  author  : Erik Mavrinac
  version : 1.10

  description: These routines manipulate bits in an unsigned int array, to
    facilitate efficient true-false/boolean arrays. Originally an idea in
    Computer Language magazine (April, 1989, pages 34-43), I have made very ex-
    tensive modifications. These routines may or may not only be able to be
    used on i80x86-- I have no way to try portability experiments.

*/

#include "bitstr.h"

/* size of unsigned int in bits */
#define US 16



void clear_bit(unsigned *string, int bit)

/* sets the "bit" bit to 0 */

{
  *(string+bit/US) &= (~(HEX1 << (US-1-(bit % US))));
}



void set_bit(unsigned *string, int bit)

/* sets the "bit" bit to 1 */

{
  *(string+bit/US) |= (HEX1 << (US-1-(bit % US)));
}



int test_bit(unsigned *string, int bit)

/* returns non-zero if "bit" is set */

{
  return (*(string+bit/US) & (HEX1 << (US-1-(bit % US))));
}

